package cn.com.tenlion.systembase.service.schoolkey;

import cn.com.tenlion.systembase.pojo.bos.schoolkey.SchoolKeyBO;
import cn.com.tenlion.systembase.pojo.dtos.school.SchoolDTO;
import cn.com.tenlion.systembase.pojo.dtos.schoolkey.SchoolKeyDTO;
import cn.com.tenlion.systembase.pojo.pos.schoolkey.SchoolKeyPO;
import cn.com.tenlion.systembase.pojo.vos.schoolkey.SchoolKeyVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ISchoolKeyService
 * @Description: 学校周边重点人员
 * @Author: CodeFactory
 * @Date: 2021-10-13 10:05:21
 * @Version: 3.0
 **/
public interface ISchoolKeyService {

    /**
     * 新增学校周边重点人员
     *
     * @param schoolKeyVO
     * @return
     */
    void save(SchoolKeyVO schoolKeyVO);

    /**
     * 新增学校周边重点人员
     *
     * @param token
     * @param schoolKeyVO
     * @return
     */
    void save(String token, SchoolKeyVO schoolKeyVO);

    /**
     * 新增学校周边重点人员
     *
     * @param schoolKeyVO
     * @return schoolKeyId
     */
    String saveReturnId(SchoolKeyVO schoolKeyVO);

    /**
     * 新增学校周边重点人员
     *
     * @param token
     * @param schoolKeyVO
     * @return schoolKeyId
     */
    String saveReturnId(String token, SchoolKeyVO schoolKeyVO);

    /**
     * 删除学校周边重点人员
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除学校周边重点人员
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除学校周边重点人员（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改学校周边重点人员
     *
     * @param schoolKeyId
     * @param schoolKeyVO
     * @return
     */
    void update(String schoolKeyId, SchoolKeyVO schoolKeyVO);

    /**
     * 修改学校周边重点人员
     *
     * @param token
     * @param schoolKeyId
     * @param schoolKeyVO
     * @return
     */
    void update(String token, String schoolKeyId, SchoolKeyVO schoolKeyVO);

    /**
     * 学校周边重点人员详情
     *
     * @param params 参数Map
     * @return
     */
    SchoolKeyDTO get(Map<String, Object> params);

    /**
     * 学校周边重点人员详情
     *
     * @param schoolKeyId
     * @return
     */
    SchoolKeyDTO get(String schoolKeyId);

    /**
     * 学校周边重点人员详情
     *
     * @param params 参数Map
     * @return
     */
    SchoolKeyBO getBO(Map<String, Object> params);

    /**
     * 学校周边重点人员详情
     *
     * @param schoolKeyId
     * @return
     */
    SchoolKeyBO getBO(String schoolKeyId);

    /**
     * 学校周边重点人员详情
     *
     * @param params 参数Map
     * @return
     */
    SchoolKeyPO getPO(Map<String, Object> params);

    /**
     * 学校周边重点人员详情
     *
     * @param schoolKeyId
     * @return
     */
    SchoolKeyPO getPO(String schoolKeyId);

    /**
     * 学校周边重点人员列表
     *
     * @param params
     * @return
     */
    List<SchoolKeyDTO> list(Map<String, Object> params);

    /**
     * 学校周边重点人员列表
     *
     * @param params
     * @return
     */
    List<SchoolKeyBO> listBO(Map<String, Object> params);

    /**
     * 学校周边重点人员列表
     *
     * @param params
     * @return
     */
    List<SchoolKeyPO> listPO(Map<String, Object> params);

    /**
     * 学校周边重点人员分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<SchoolKeyDTO>> listPage(ListPage page);

    /**
     * 学校周边重点人员统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, SchoolKeyVO schoolKeyVO, SchoolDTO schoolDTO);

    void updateKafka(String uid, SchoolKeyVO schoolKeyVO, SchoolDTO schoolDTO);

    void deleteKafka(String uid);

}